// DirFlatten.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace std;

bool doDirectory(const char *szRootPath, string strDirectory, string strDirectoryNameOnly, string strFlatPath, string strParentFlatPath);

int main(int argc, char* argv[])
{
	if (argc != 2)
	{
		printf("Give directory path to flatten as argument.\n");
	}
	else if (!doDirectory(argv[1], argv[1], "", "", ""))
	{
		printf("\n\n***Failed\n");
	}

	return(0);
}

bool doDirectory(const char *szRootPath, string strDirectory, string strDirectoryNameOnly, string strFlatPath, string strParentFlatPath)
{
	bool result = true;

	string nEntry;
	string strChildFlatPath;

	list<string> dirs;
	list<string> files;

	struct _finddata_t fileinfo;

	char searchPath[_MAX_PATH];

	sprintf(searchPath, "%s\\*.*", strDirectory.c_str());

	long fr = _findfirst(searchPath, &fileinfo);

	if ((-1) == fr)
	{
		printf("ERROR scanning for %s\n", (const char *)searchPath);
		result = false;
	}
	else
	{
		do
		{
			if (fileinfo.attrib & _A_SUBDIR)
			{
				if (strcmp(".", fileinfo.name) && strcmp("..", fileinfo.name))
				{
					// For some reason, when running under the IDE some combinations of filename give us an error
					// unless we erase the string after using it.
					nEntry = fileinfo.name;
					dirs.push_back(nEntry);
					nEntry.erase();
				}
			}
			else
			{
				// For some reason, when running under the IDE some combinations of filename give us an error
				// unless we erase the string after using it.
				nEntry = fileinfo.name;
				files.push_back(nEntry);
				nEntry.erase();
			}
		} while (0 == _findnext(fr, &fileinfo));

		_findclose(fr);

		dirs.sort();
		files.sort();

		char fullEntryPath[_MAX_PATH];

		if (!dirs.empty())
		{
			int dirNum = 0;

			int dirDigits = 0;

			char *szFlatAppendage = NULL;

			if (1 != dirs.size())
			{
				dirDigits = ceil(log(dirs.size() - 1)/log(10));

				if (1 > dirDigits)
				{
					dirDigits = 1;
				}

				szFlatAppendage = new char[dirDigits + 1];
			}

			while (! dirs.empty() )
			{
				nEntry = dirs.front();
				dirs.pop_front();

				sprintf(fullEntryPath, "%s\\%s", strDirectory.c_str(), nEntry.c_str());

				strChildFlatPath = strFlatPath;

				if (0 != dirDigits) // Don't add to flat path when there's only one directory.
				{
					sprintf(szFlatAppendage, "%0*d", dirDigits, dirNum++);

					if (!strChildFlatPath.empty())
					{
						strChildFlatPath += "_";
					}

					strChildFlatPath += szFlatAppendage;
				}

				if (! doDirectory(szRootPath, fullEntryPath, nEntry.c_str(), strChildFlatPath, strFlatPath) )
				{
					result = false;

					break;
				}
			}

			delete [] szFlatAppendage;
		}

		if (!strFlatPath.empty())
		{
			while (! files.empty() )
			{
				nEntry = files.front();
				files.pop_front();

				sprintf(fullEntryPath, "%s\\%s", strDirectory.c_str(), nEntry.c_str());

				strChildFlatPath = szRootPath;

				if ((!strChildFlatPath.empty())
				&&	('\\' != strChildFlatPath.at(strChildFlatPath.length() - 1))
				&&	('/'  != strChildFlatPath.at(strChildFlatPath.length() - 1)))
				{
					strChildFlatPath += '\\';
				}

				if (!strParentFlatPath.empty())
				{
					strChildFlatPath += strParentFlatPath;
					strChildFlatPath += "_";
				}

				if (!strDirectoryNameOnly.empty())
				{
					strChildFlatPath += strDirectoryNameOnly;
					strChildFlatPath += "_";
				}

				strChildFlatPath += nEntry.c_str();

				if (! MoveFile(fullEntryPath, strChildFlatPath.c_str()) )
				{
					printf("\n\n*** Failed to move: %s\n to %s\n\n", fullEntryPath, strChildFlatPath.c_str());

					result = false;

					break;
				}
				else
				{
					printf("%s\n", strChildFlatPath.c_str());
				}
			}
		}
	}

	return(result);
}
